# Sample code for exercise 1-2
# 2017 Augst Tsuyoshi Okubo

import numpy as np
import scipy.linalg as linalg
import ED
from matplotlib import pyplot

N=10           ## Chain length 
m = 3         ## m = 2S + 1, e.g. m=3 for S=1 
Delta = 1.0   ## Delta for XXZ
hx = 0.0      ## external field along x direction
D = 0.0       ## single ion anisotropy

eig_val,eig_vec = ED.Calc_GS(m,Delta,hx,D,N,k=1)


print "S=1 N-site open Heisenberg chain"
print "N=",N
print "Ground state energy per bond=", eig_val[0]/(N-1)

## Make matrix from wave function
Mat = eig_vec[:,0].reshape(m**(N/2),m**(N-N/2))

## SVD
U,s,VT = linalg.svd(Mat,full_matrices=False)

## Entanglement entropy
print "normalization=",np.sum(s**2)
s /= np.sqrt(np.sum(s**2))
EE = -np.sum(s**2*np.log(s**2))
print "EE=",EE

## plot singular values
pyplot.title(repr(N)+" sites S=1 Heisenberg chain")
pyplot.plot(np.arange(m**(N/2)),s,"o")
pyplot.xlabel("index")
pyplot.ylabel("sigular value")
pyplot.yscale("log")
pyplot.show()

    
